﻿// JScript 文件
var cfg_sensor_header = new Array(str_ch,str_enabel,str_sensorname,str_type,str_holdtimes,str_trigger);
var cfg_sensor_ptz_header = new Array(str_ch,str_type,str_no);

function OnLoadCfgSensorAlarm()
{
    ApplyXmlLang("cfg_sensor_alarm.xml");
    CreateListSensor(id_sensor_alarm,6,cfg_sensor_header, g_sensorList.length);	
    GenSelectListEx(all_sensor_in_type, g_sensorInType);
    GenSelectListEx(all_sensor_in_hold_time, g_alarmOutHoldTime);
    
    GenCheckGroup(sensor_trigger_out, g_alarmoutList,STR_SENSOR_IN_TO_ALARM_OUT+"_ctrl",4,Btrigger);
    if(g_alarmoutList.length > 1)
    {
        sensor_trigger_out.className += " " +"user_gen_table";
    }
    else
    {
        sensor_trigger_out.style.border = "0";
        sensor_trigger_out.cells[0].style.border = "0";
    }
    GenCheckGroup(sensor_trigger_record, g_channelList,STR_SENSOR_IN_TO_RECORD+"_ctrl",4,Btrigger);
	SensorTriggerPTZ(id_sensor_ptz, 3,cfg_sensor_ptz_header, g_channelList.length);
	var xmlConfigReq = CreateConfigReqXml(sensor_config_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return false;
	}
//		window.alert(xmlConfigReply);
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	UpdateValues(paramElements, true);
	cfgCopy2All(sensor_all_cfg,id_sensor_alarm,id_sensor_all);
	
	AlarmGetCruiseList(paramElements);
	
	all_sensor_in_enable.checked = true;
    all_sensor_in_hold_time.value = 10;
}
function LoadDefaultCfgSensorAlarm()
{
    if(GetDefaultCfg(sensor_config_array))
    {
        onSensorPTZCancel();
        
        var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
        UpdateValues(paramElements, true);
	    cfgCopy2All(sensor_all_cfg,id_sensor_alarm,id_sensor_all);
	    
	    AlarmGetCruiseList(paramElements);
	    
	    g_bChange = true;
	    bTrigger = true;
    }
}
/***********************************************************************************/
/********************SENSOR报警配置页面动态生成表格*********************************/
/***********************************************************************************/
function CreateListSensor(htmlObj, colNum, colHeaders, rowInitNum)
{
	var strOuterHTML = htmlObj.outerHTML.toLowerCase();
	var lengthLimit = strOuterHTML.indexOf("</tbody>");
	strOuterHTML = strOuterHTML.substr(0, lengthLimit);
	//添加标题行
	strOuterHTML += "<tr style='background-color:#D4E8FE'>";
	for(var i = 0; i < colNum; i++)
	{
		strOuterHTML += "<td style = \"text-align:center\">" + colHeaders[i] + "</td>";
	}
	strOuterHTML += "</tr>";
	//添加数据行
	for(var i = 1; i < rowInitNum + 1; i++)
	{
		strOuterHTML += "<tr>";
		strOuterHTML += "<td style = \"text-align:center;width:50px;\">"+i+"</td>";
	    strOuterHTML += "<td><input type = \"checkbox\" style = \"width:50px\" name = \"sensor_in_enable\" onchange = \"g_bChange = true;\"/></td>";
	    strOuterHTML +="<td><input type = \"text\" name = \"sensor_in_name\" style = \"width:155px\" onkeydown = \"return LenCheck(this,event,const_sensor_name_max_len);\" onkeyup = \"return KeyupCheck(this,const_sensor_name_max_len);\" onchange = \"g_bChange = true;\"></td>";
	    strOuterHTML +="<td><select style = \"width:85px\" onchange = \"g_bChange = true;\" name = \"sensor_in_type\"></select></td>";
	    strOuterHTML +="<td><select style = \"width:115px\" onchange = \"g_bChange = true;\" name = \"sensor_in_hold_time\"></select></td>";
	    strOuterHTML += "<td align = \"center\" style = \"width:224px\"><input style = \"width:145px; height:25px; border:0; background:url(res/145x25_btn.jpg);cursor:pointer;\" type = \"button\" value = "+set_button+" onclick = \"OnDisOrHidSensor("+(i-1)+")\"/></td>";
		strOuterHTML += "</tr>";
	}
	strOuterHTML += "</tbody></table>";
	var parentNode = htmlObj.parentElement;
	parentNode.innerHTML = strOuterHTML;
	for(var i = 1; i < rowInitNum + 1; i++)
	{
		GenSelectListEx(document.getElementsByName("sensor_in_type")[i-1], g_sensorInType);
	    GenSelectListEx(document.getElementsByName("sensor_in_hold_time")[i-1], g_alarmOutHoldTime);
	}
	htmlObj = parentNode.childNodes[0];
}
/***********************************************************************************/
/*********************sensor配置页面云台动态生成表格********************************/
/***********************************************************************************/
function SensorTriggerPTZ(htmlObj, colNum, colHeaders, rowInitNum)
{
	var strOuterHTML = htmlObj.outerHTML.toLowerCase();
	var lengthLimit = strOuterHTML.indexOf("</tbody>");
	strOuterHTML = strOuterHTML.substr(0, lengthLimit);
	//添加标题行
	strOuterHTML += "<tr style='background-color:#D4E8FE'>";
	for(var i = 0; i < colNum; i++)
	{
		strOuterHTML += "<td style = \"text-align:center\">" + colHeaders[i] + "</td>";
	}
	strOuterHTML += "</tr>";
	//添加数据行
	for(var i = 1; i < rowInitNum + 1; i++)
	{
		strOuterHTML += "<tr>";
		strOuterHTML += "<td style = \"width:180px;text-align:center\">"+i+"</td>";
	    strOuterHTML +="<td><select style = \"width:260px\" name = \"ptz_type\" onchange = \"onMotionChangePtzType(this,"+i+");bTrigger = true\"></select></td>";
	    strOuterHTML +="<td><select style = \"width:260px\" name = \"ptz_number\"onchange = \"bTrigger = true;\"></select></td>";
		strOuterHTML += "</tr>";
	}
	strOuterHTML += "</tbody></table>";
	var parentNode = htmlObj.parentElement;
	parentNode.innerHTML = strOuterHTML;
	for(var i = 1; i < rowInitNum + 1; i++)
	{
	    GenSelectListEx(document.getElementsByName("ptz_type")[i-1], g_motionPTZType);
		if(ptz_type.value == 2)	//g_cruiseList
		{
			GenSelectListEx(document.getElementsByName("ptz_number")[i-1], g_cruiseList[i-1]);
		}
		else	//定码率
		{
			GenSelectListEx(document.getElementsByName("ptz_number")[i-1], g_presetList);
		}
	}
	htmlObj = parentNode.childNodes[0];
}


/*******************Sensor报警界面Trigger界面的显示与隐藏********************/
function OnDisOrHidSensor(index)
{
    var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
    UpdateBooleanTrigger(paramElements, STR_SENSER_IN_BUZZ, STR_SENSER_IN_BUZZ+"_ctrl", false);
    UpdateBooleanTrigger(paramElements, STR_SENSOR_IN_TO_EMAIL, STR_SENSOR_IN_TO_EMAIL+"_ctrl", false);
    UpdateAlarmTrigger(paramElements, STR_SENSOR_IN_TO_ALARM_OUT, STR_SENSOR_IN_TO_ALARM_OUT+"_ctrl", false);
    UpdateAlarmTrigger(paramElements, STR_SENSOR_IN_TO_RECORD, STR_SENSOR_IN_TO_RECORD+"_ctrl", false);
    UpdateBigView(paramElements, STR_SENSOR_IN_TO_BIGVIEW, STR_SENSOR_IN_TO_BIGVIEW+"_ctrl", false);
    UpdateAlarmToPtz(paramElements, false, g_curchannel_sensor);
    div_sensor_trigger.style.display = "";
    id_cp_sensor.style.display = "";
    sensor_index_num.innerHTML = "<b>"+channel_string +(index+1)+"</b>";
    g_curchannel_sensor = index;
    for(i = 0 ; i < g_channelList.length; i++)
    {
        document.getElementsByName("ptz_type")[i].disabled = false;
        document.getElementsByName("ptz_number")[i].disabled = false;
    }
    for(k = 0; k < g_bUpdataChannel.length; k++)
    {
        if(k != index)
        {
            g_bUpdataChannel[k] = 0;
        }
        else
        {
            g_bUpdataChannel[k] = 1;
        }
    }
    GenSelectListEx(sensor_in_to_bigview_ctrl, g_bigViewList);
    var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
    UpdateBooleanTrigger(paramElements, STR_SENSER_IN_BUZZ, STR_SENSER_IN_BUZZ+"_ctrl", true);
    UpdateBooleanTrigger(paramElements, STR_SENSOR_IN_TO_EMAIL, STR_SENSOR_IN_TO_EMAIL+"_ctrl", true);
    UpdateAlarmTrigger(paramElements, STR_SENSOR_IN_TO_ALARM_OUT, STR_SENSOR_IN_TO_ALARM_OUT+"_ctrl", true);
    UpdateAlarmTrigger(paramElements, STR_SENSOR_IN_TO_RECORD, STR_SENSOR_IN_TO_RECORD+"_ctrl", true);
    UpdateBigView(paramElements, STR_SENSOR_IN_TO_BIGVIEW, STR_SENSOR_IN_TO_BIGVIEW+"_ctrl", true);
    UpdateAlarmToPtz(paramElements, true, g_curchannel_sensor);
    GenCpList(cp_config_sensor,index, g_sensorList);
    UpdateCheckItems(sensor_trigger_out);
    UpdateCheckItems(sensor_trigger_record);
	Align();
    EdgeCtrl(div_config_index,72);
    location.href = "#sensor_all_label";
}
function onSensorPTZSave()
{
    if(!bTrigger)
    {
        window.alert(cfg_nochange_tip);
    }
    else
    {
        var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
        UpdateBooleanTrigger(paramElements, STR_SENSER_IN_BUZZ, STR_SENSER_IN_BUZZ+"_ctrl", false);
        UpdateBooleanTrigger(paramElements, STR_SENSOR_IN_TO_EMAIL, STR_SENSOR_IN_TO_EMAIL+"_ctrl", false);
        UpdateAlarmTrigger(paramElements, STR_SENSOR_IN_TO_ALARM_OUT, STR_SENSOR_IN_TO_ALARM_OUT+"_ctrl", false);
        UpdateAlarmTrigger(paramElements, STR_SENSOR_IN_TO_RECORD, STR_SENSOR_IN_TO_RECORD+"_ctrl", false);
        UpdateBigView(paramElements, STR_SENSOR_IN_TO_BIGVIEW, STR_SENSOR_IN_TO_BIGVIEW+"_ctrl", false);
        UpdateAlarmToPtz(paramElements, false, g_curchannel_sensor);
        div_sensor_trigger.style.display = "none";
	    Align();
        EdgeCtrl(div_config_index,72);
    }
    
    for(k = 0; k < g_bUpdataChannel.length; k++)
    {
        g_bUpdataChannel[k] = 0;
	}
}
function onSensorPTZCancel()
{
    div_sensor_trigger.style.display = "none";
	Align();
    EdgeCtrl(div_config_index,72);
    
    for(k = 0; k < g_bUpdataChannel.length; k++)
    {
        g_bUpdataChannel[k] = 0;
	}
}
function disAllsensor()
{
    div_sensor_trigger.style.display = "";
    id_cp_sensor.style.display = "none";
    sensor_index_num.innerHTML = "<b>"+str_all_channel+"</b>";
    UpdateCheckItems(sensor_trigger_out);
    UpdateCheckItems(sensor_trigger_record);
    
    GenSelectListEx(sensor_in_to_bigview_ctrl, g_bigViewList);
    
	Align();
    EdgeCtrl(div_config_index,72);
    
    location.href = "#sensor_all_label";
}
function ConstSensorLen()
{
    var error_message1 = "";
    var error_message2 = "";
	var isValid = true;
	for(i = 0; i < g_alarmoutList.length; i++)
	{
        sensor_name_len = sensor_in_name[i].value.length
        if (sensor_name_len>const_sensor_name_max_len)
        {
           error_message1 = str_sensor_name_len + cannot_more_than_tip + const_sensor_name_max_len + character;
           isValid = false;
        }
        if(sensor_name_len == 0)
        {
            error_message2 = str_sensor_name_len + str_empty_tip;
            isValid = false;
        }
	}
	if(!isValid)
	{
	    sensorconfig_errortips.style.color = "red";
		sensorconfig_errortips.innerHTML = save_error_tip+error_message1+error_message2;
		bTrigger = false;
		g_bChange = false;
		return false;
	}
	sensorconfig_errortips.innerHTML = "";
	sensorconfig_errortips.display = "none";
	return true;
}
