﻿// JScript 文件

var g_diskInfoArray = new Array();
var g_diskTypeName = new Array("IDE", "SATA", "USB", "REMDISK", "ESATA", "SD", "CD/DVD");
var g_diskStatusName = new Array(str_normal, str_notformatted, str_nocd, str_mounted, str_notmounted);
var g_diskProperty = new Array(
        new CSelectOptionInfo(str_readwrite, 0), 
        new CSelectOptionInfo(str_readonly, 1),
        new CSelectOptionInfo(str_redundancy, 2));
var g_diskOwnerName = new Array(str_this, str_other);

var g_curSelDisk = -1;
var g_formatThread = -1;

function DiskInfo(diskTypeGroup, diskType, diskSize, diskFree, diskStatus, diskProperty, diskOwner)
{
    this.diskTypeGroup = diskTypeGroup;
    this.diskType = diskType;
    this.diskSize = diskSize;
    this.diskFree = diskFree;
    this.diskStatus = diskStatus;
    this.diskProperty = diskProperty;
    this.diskOwner = diskOwner;
}

function GotoAdvancePage()
{
	if(g_mainMenuItem == 3)
	{
		HintSave(-1);
	}
	g_mainMenuItem = 4;
	g_lastNav = null;
    selected(g_mainMenuItem);
    HideDIVs();
	div_main_menu.style.display		= "";
	div_advance_body.style.display   = "";
	
	g_lastNav = "";
	g_lastNavSec = "";
	
    g_xmlhttp.Open("get", "body_html/body_advance.html", false);
//    g_xmlhttp.onreadystatechange = OnReceiveAdvance;
    SafeHttpSend(g_xmlhttp, null);
    OnReceiveAdvance();
}

function OnReceiveAdvance()
{
    if (g_xmlhttp.readyState != 4) 
    {
        return;
    }
    div_advance_body.innerHTML = g_xmlhttp.responseText;
    
    for(var i = 0; i < disk_property.length; i++)
    {
        disk_property[i].style.width = "100%";
        disk_property[i].style.display = "none";
    }
    
    searchNavS(diskmanager_nav);
    ApplyXmlLang("advance.xml");
    EdgeCtrl(div_advance_nav,78);
    
    if(!g_supportFunctions.IsSupportDiskMan())
    {
        diskm_apply_btn.style.display = "none";
        diskm_format_btn.style.display = "none";
    }
    
    GotoDiskManager();
}
function GotoDiskManager()
{
    var cfgItemArray = new Array(STR_SUPPORT_REC_REDUNDANCY);
    var xmlConfigReq = CreateConfigReqXml(cfgItemArray);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
    OnConstItemProc(xmlConfigReply);

    advance_dismanager_div.style.display = "";
    advance_upgrade_div.style.display = "none";
    diskm_format_btn.disabled = true;
    
    if(!g_supportRecRedundancy)
    {
        g_diskProperty.splice(2,1);
    }
    
    for(var i = 1; i < advance_diskm_table.rows.length; i++)
    {
        advance_diskm_table.rows[i].onclick = function()
        {
            g_curSelDisk = -1;
            diskm_format_btn.disabled = true;
            for(var k = 1; k < advance_diskm_table.rows.length; k++)
            {
                if(advance_diskm_table.rows[k] != this)
                {
                    advance_diskm_table.rows[k].style.backgroundColor="";
                    advance_diskm_table.rows[k].style.color="";
                }
                else
                {
                    if(this.cells[0].innerText != " ")
                    {
                        g_curSelDisk = k-1;
                        this.style.backgroundColor="#316AC5";
                        this.style.color="White";
                        
                        if(g_diskInfoArray[g_curSelDisk].diskTypeGroup == 0)
                        {
                            diskm_format_btn.disabled = false;
                        }
                    }                  
                }
            }
        }
        advance_diskm_table.rows[i].onmouseover = function()
        {
            if((g_curSelDisk == -1) || (advance_diskm_table.rows[g_curSelDisk+1] != this))
            {
                if(this.cells[0].innerText != " ")
                {
                    this.style.backgroundColor = "#e0f0ff";
                }
            }        
        }
        advance_diskm_table.rows[i].onmouseout = function()
        {
            if(this.style.backgroundColor.toLowerCase() == "#e0f0ff")
            {
                this.style.backgroundColor = "";
            }
        }
    }
    
    if(g_authority.authority & 4096)
    {
        GetDiskInfo();
    }
    else
    {
        diskm_refresh_btn.disabled = true;
        diskm_apply_btn.disabled = true;
        diskm_format_btn.disabled = true;
        window.alert(str_no_auth);
    }
}

function GotoUpgrade()
{
    advance_dismanager_div.style.display = "none";
    advance_upgrade_div.style.display = "";
}

function OnChangeDiskProperty()
{
    diskm_apply_btn.disabled = true;
    for(var index = 0; index < g_diskInfoArray.length; index++)
    {
        if(g_diskInfoArray[index].diskProperty != disk_property[index].value)
        {
            diskm_apply_btn.disabled = false;
            break;
        }
    }
}

function GetDiskInfo()
{
    g_diskInfoArray = new Array();
    
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_DISK_MAN_START+"\">\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    var strReply = WebClient.ExcuteCmd(strRequest);
//  window.alert(strReply);
    if(strReply == "")
    {
        return;
    }
    
    g_xmlDoc.async = false;
    g_xmlDoc.loadXML(strReply);
    var cmdElement = g_xmlDoc.documentElement.childNodes[0];
    
    if(cmdElement.getAttribute("name") == STR_DISK_MAN_RESULT)
    {
        window.alert(str_someone_format_disk);
    }
    else
    {
        var itemElement = cmdElement.childNodes;
        for(var i = 0; i < itemElement.length; i++)
        {
            var diskTypeGroup = itemElement[i].getElementsByTagName(STR_DISK_TYPE_GROUP)[0].childNodes[0].nodeValue;
            var diskType = itemElement[i].getElementsByTagName(STR_DISK_TYPE)[0].childNodes[0].nodeValue;
            var diskSize = itemElement[i].getElementsByTagName(STR_DISK_SIZE)[0].childNodes[0].nodeValue;
            var diskFree = itemElement[i].getElementsByTagName(STR_DISK_FREE_SPACE)[0].childNodes[0].nodeValue;
            var diskStatus = itemElement[i].getElementsByTagName(STR_DISK_STATUS)[0].childNodes[0].nodeValue;
            var diskProperty = itemElement[i].getElementsByTagName(STR_DISK_PROPERTY)[0].childNodes[0].nodeValue;
            var diskOwner = itemElement[i].getElementsByTagName(STR_DISK_OWNER)[0].childNodes[0].nodeValue;
            g_diskInfoArray[i] = new DiskInfo(diskTypeGroup, diskType, diskSize, diskFree, diskStatus, diskProperty, diskOwner);
        }
    }
    
    DisplayDisk();
}

function DisplayDisk()
{
    var rows = advance_diskm_table.rows;
    for(var i = 0; i < g_diskInfoArray.length; i++)
    {                    
        rows[i+1].cells[0].innerText = i+1;
        rows[i+1].cells[1].innerText = g_diskTypeName[g_diskInfoArray[i].diskType];
        rows[i+1].cells[2].innerText = g_diskInfoArray[i].diskSize;
        rows[i+1].cells[3].innerText = g_diskInfoArray[i].diskFree;
        rows[i+1].cells[6].innerText = g_diskOwnerName[g_diskInfoArray[i].diskOwner];
        
        disk_property[i].style.display = "";
        disk_property[i].disabled = true;
        
        if((g_diskInfoArray[i].diskTypeGroup == 0) && (g_diskInfoArray[i].diskOwner == 0))   //固定磁盘
        {
            GenSelectListEx(disk_property[i], g_diskProperty);
            rows[i+1].cells[4].innerText = g_diskStatusName[g_diskInfoArray[i].diskStatus];
            disk_property[i].value = g_diskInfoArray[i].diskProperty;
            if(g_diskInfoArray[i].diskStatus == 0)
            {
                disk_property[i].disabled = !g_supportFunctions.IsSupportDiskMan();
            }
        }
        else
        {
            var property = new Array();
            property[0] = g_diskProperty[0];
            GenSelectListEx(disk_property[i], property);
            disk_property[i].value = 0; //always readwrite
            
            if(g_diskInfoArray[i].diskTypeGroup == 1)   // USB
            {
                rows[i+1].cells[4].innerText = g_diskStatusName[0];
            }
            else    // CD/DVD
            {
                rows[i+1].cells[4].innerText = g_diskStatusName[g_diskInfoArray[i].diskStatus];
            }
        }
    }
    for(i = g_diskInfoArray.length; i < (rows.length-1); i++)
    {
        rows[i+1].cells[0].innerText = " ";
        rows[i+1].cells[1].innerText = "";
        rows[i+1].cells[2].innerText = "";
        rows[i+1].cells[3].innerText = "";
        rows[i+1].cells[4].innerText = "";
        rows[i+1].cells[6].innerText = "";
        disk_property[i].style.display = "none";
    }
    for(i = 1; i < rows.length; i++)
    {
        advance_diskm_table.rows[i].style.backgroundColor="";
        advance_diskm_table.rows[i].style.color="";
    }
    diskm_format_btn.disabled = true;
}

function FormatDisk()
{
    if(!confirm(str_confirm_format_disk))
    {
        return;
    }
    var cmdElement = g_xmlDoc.documentElement.childNodes;
    var itemElement = cmdElement[0].childNodes;
    
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_FORMAT_DISK_START+"\">\r\n";
    strRequest += itemElement[g_curSelDisk].xml;
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    var strReply = WebClient.ExcuteCmd(strRequest);
    
    if(strReply == "")
    {
        return;
    }
    
    g_xmlDoc.async = false;
    g_xmlDoc.loadXML(strReply);
    
    cmdElement = g_xmlDoc.documentElement.childNodes[0];
    if(cmdElement.attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
    {
        window.alert(str_no_auth);
        return;
    }
    
    if(cmdElement.childNodes[0].nodeValue == STR_SUCCESS)
    {
        InitProgressBar();
        StartWaitTip(str_disk_format_wait_tip);
        g_formatThread = setTimeout("GetFormatPercent()", 500);
    }
    else
    {
        if(cmdElement.childNodes[0].nodeValue == STR_DISK_BUSY_PB_BK)
        {
            window.alert(str_disk_busy_pb_bk);
        }
        GetDiskInfo();
    }
}

function ApplyDiskSettings()
{
    if(!confirm(str_confirm_disk_settings))
    {
        return;
    }
    var cmdElement = g_xmlDoc.documentElement.childNodes;
    var itemElement = cmdElement[0].childNodes;
    
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_DISK_CHANGE_PROPERTY+"\">\r\n";
    
    var nChangeCount = 0;
    for(var i = 0; i < itemElement.length; i++)
    {
        if(g_diskInfoArray[i].diskProperty != disk_property[i].value)
        {
            itemElement[i].getElementsByTagName(STR_DISK_TEMP)[0].childNodes[0].nodeValue = disk_property[i].value;
            strRequest += itemElement[i].xml;
            nChangeCount++;
        }        
    }
    
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
        
    if(nChangeCount == 0)
    {
        return;
    }
    
    var strReply = WebClient.ExcuteCmd(strRequest);
    
    if(strReply == "")
    {
        return;
    }
    
    g_xmlDoc.async = false;
    g_xmlDoc.loadXML(strReply);
    
    cmdElement = g_xmlDoc.documentElement.childNodes[0];
    if(cmdElement.attributes.getNamedItem("name").nodeValue == STR_REPLY_NO_AUTH)
    {
        window.alert(str_no_auth);
        return;
    }
    
    if(cmdElement.childNodes[0].nodeValue == STR_SUCCESS)
    {
        window.alert(str_disk_config_succ);
    }
    else if(cmdElement.childNodes[0].nodeValue == STR_DISK_FORMATTING)
    {
//        widow.alert(str_someone_format_disk);
    }
    else if(cmdElement.childNodes[0].nodeValue == STR_DISK_IO_ERROR)
    {
        window.alert(str_disk_io_error);
    }
    else if(cmdElement.childNodes[0].nodeValue == STR_DISK_BUSY_PB_BK)
    {
        window.alert(str_disk_busy_pb_bk);
    }
    else
    {
        window.alert(str_disk_config_fail);
    }
    
    diskm_apply_btn.disabled = true;
    
    GetDiskInfo();
}

function GetFormatPercent()
{
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_DISK_FORMAT_PERCENT+"\">\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    var strReply = WebClient.ExcuteCmd(strRequest);
    if(strReply == "")
    {
        DestroyProgressBar();
        clearTimeout(g_formatThread);
        return;
    }
    
    g_xmlDoc.async = false;
    g_xmlDoc.loadXML(strReply);
    var cmdElement = g_xmlDoc.documentElement.childNodes[0];
    var progress = cmdElement.getElementsByTagName(STR_DISK_FORMAT_PROGRESS)[0].childNodes[0].nodeValue;
    
    if(progress == "101")
    {
        StopWaitTip();
        clearTimeout(g_formatThread);
        window.alert(str_disk_format_fail);
        DestroyProgressBar();
        
        StopDiskFormat();
    }
    else if(progress == "100")
    {
        StopWaitTip();
        disk_formatted.style.width = "600px";
        disk_unformatted.style.display = "none";
        disk_format_label.innerText = "100%";
        
        clearTimeout(g_formatThread);
        window.alert(str_disk_format_finish);
        DestroyProgressBar();
            
        StopDiskFormat();
        GetDiskInfo();
    }
    else
    {
        var formatted = 600*parseInt(progress, 10)/100;
        if(formatted > 0)
        {
            disk_formatted.style.display = "";
        }
        disk_formatted.style.width = formatted + "px";
        disk_unformatted.style.width = (600-formatted) + "px";
        disk_format_label.innerText = progress + "%";
        g_formatThread = setTimeout("GetFormatPercent()", 500);
    }
}

function StopDiskFormat()
{
    var strRequest = "<request>\r\n";
    strRequest += "<command name=\""+STR_FORMAT_DISK_STOP+"\">\r\n";
    strRequest += "</command>\r\n";
    strRequest += "</request>\r\n";
    
    WebClient.ExcuteCmd(strRequest);
}

function InitProgressBar()
{
    disk_progress_table.style.display = "";
    disk_formatted.style.display = "none";
}

function DestroyProgressBar()
{
    disk_progress_table.style.display = "none";
    disk_formatted.style.display = "none";
    disk_formatted.style.width = "0px";
    disk_unformatted.style.width = "600px";
}
