﻿var cfg_netstream_header = new Array(str_ch,str_resolution,str_rate,str_encodetype,str_quality,str_maxbitrate);

var g_bNetworkPassTest = true;
var g_bDDNSPassTest = true;

function OnLoadCfgNetwork()
{
    ApplyXmlLang("cfg_net.xml");
    g_curConfigIndex = 61;
	GenSelectListEx(ddns_type, g_ddnsDomainInfo);
	GenSelectListEx(ddns_update_cycle, g_ddnsUpdateServer);
	
	ddns_type.value = 0;
    var ip1=new MultiEdit("ip1", 1);
    ip_address.innerHTML=ip1;
    ip_address.ipName = "ip1";
    var ip2=new MultiEdit("ip2", 1);
    net_mask.innerHTML=ip2;
    net_mask.ipName = "ip2";
    var ip3=new MultiEdit("ip3", 1);
    gate_way.innerHTML=ip3;
    gate_way.ipName = "ip3";
    var ip4=new MultiEdit("ip4", 1);
    net_dns1.innerHTML=ip4;
    net_dns1.ipName = "ip4";
    var ip5=new MultiEdit("ip5", 1);
    net_dns2.innerHTML=ip5;
    net_dns2.ipName = "ip5";
	var xmlConfigReq = CreateConfigReqXml(net_config_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return false;
	}
	
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
// 	window.alert(xmlConfigReply);
	UpdateValues(g_xmlDoc.documentElement.childNodes[0].childNodes, true);
	UpdateNetwork(true);
	PPPoeEnable(pppoe_enable);
	DdnsEnable(ddns_enable);
	IPAuto(autoIp);
	IPStatic(staticIP);
}

function LoadDefaultCfgNetwork()
{
    if(GetDefaultCfg(net_config_array))
    {
        UpdateValues(g_xmlDoc.documentElement.childNodes[0].childNodes, true);
	    UpdateNetwork(true);
	    PPPoeEnable(pppoe_enable);
	    DdnsEnable(ddns_enable);
	    IPAuto(autoIp);
	    IPStatic(staticIP);
	    g_bChange = true;
    }
}

function OnLoadCfgNetStream()
{
    ApplyXmlLang("cfg_net_stream.xml");
    CreateListNet(id_net_stream_cfg, g_channelList.length);
	GenSelectListEx(all_net_resolution, g_minorEncodeProperty);
	GenSelectListEx(all_net_encode_type, g_avNetStreamInfo.supportEncodeMode);
    GenSelectListEx(all_net_maxbit_stream, g_avNetStreamInfo.supportBitrate);
    GenSelectListEx(all_net_video_quality, g_avNetStreamInfo.supportQuarlity);
    
    //给统一配置设定默认值
    all_net_resolution.value = g_avNetStreamInfo.defaultResolution;
    all_net_encode_type.value = g_avNetStreamInfo.defaultEncodeMode;
    all_net_maxbit_stream.value = g_avNetStreamInfo.defaultBitrate;
    all_net_video_quality.value = g_avNetStreamInfo.defaultQuarlity;
    
	var xmlConfigReq = CreateConfigReqXml(net_stream_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return false;
	}
	
	//	window.alert(xmlConfigReply);
	//更新到页面
    g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	UpdateNetStreamCfg(true);
	
	for(var m = 0; m < g_channelList.length; m++)
	{
	    OnNetChangeResolution(net_resolution[m], m);
	}
	OnAllNetChangeResolution(all_net_resolution);
	var defaultFrameRate = (g_videoFormat=="PAL") ? g_avNetStreamInfo.defaultChnnRateNumPal : g_avNetStreamInfo.defaultChnnRateNumNtsc;
    all_net_frame_rate.value = defaultFrameRate;//RealFrameRate(defaultFrameRate, g_avNetStreamInfo.defaultResolution);
	
	UpdateNetStreamCfg(true);	
	
	OnNetStreamCheckAll();
	
	for(var m = 0; m < net_frame_rate.length; m++)
	{
	    net_frame_rate[m].disabled = true;
	}

    var totalFrameRate = (g_videoFormat == "PAL") ? g_avNetStreamInfo.totalRatePalOnCif : g_avNetStreamInfo.totalRateNtscOnCif;
	var frameNum = 0;
    for(var ch = 0; ch < net_frame_rate.length; ch++)
    {
        frameNum += ConvertCifRate(parseInt(net_frame_rate[ch].value, 10), parseInt(net_resolution[ch].value, 10));
    }
    
    var leftSource = (totalFrameRate - frameNum);
    remain_source.innerText = str_source_remain + ": " + leftSource + "(CIF) , " + Math.floor(leftSource/4) + "(D1).";
}

function LoadDefaultCfgNetStream()
{
    if(GetDefaultCfg(net_stream_array))
    {
        UpdateNetStreamCfg(true);
        
        for(var m = 0; m < g_channelList.length; m++)
	    {
	        OnNetChangeResolution(net_resolution[m], m);
	    }
	    OnAllNetChangeResolution(all_net_resolution);
	    var defaultFrameRate = (g_videoFormat=="PAL") ? g_avNetStreamInfo.defaultChnnRateNumPal : g_avNetStreamInfo.defaultChnnRateNumNtsc;
        all_net_frame_rate.value = defaultFrameRate;//RealFrameRate(defaultFrameRate, g_avNetStreamInfo.defaultResolution);
	
	    UpdateNetStreamCfg(true);	
	    OnNetStreamCheckAll();

        for(var m = 0; m < net_frame_rate.length; m++)
	    {
	        net_frame_rate[m].disabled = true;
	    }
	    g_bChange = true;
	
	    var totalFrameRate = (g_videoFormat == "PAL") ? g_avNetStreamInfo.totalRatePalOnCif : g_avNetStreamInfo.totalRateNtscOnCif;    
	    var frameNum = 0;
        for(var ch = 0; ch < net_frame_rate.length; ch++)
        {
            frameNum += ConvertCifRate(parseInt(net_frame_rate[ch].value, 10), parseInt(net_resolution[ch].value, 10));
        }
        
        var leftSource = (totalFrameRate - frameNum);
        remain_source.innerText = str_source_remain + ": " + leftSource + "(CIF) , " + Math.floor(leftSource/4) + "(D1).";
    }
}

function OnNetStreamCheckAll()
{
    cfgCopy2All(net_all_cfg,id_net_stream_cfg,id_net_stream_all);
    
    if(net_all_cfg.checked)
    {
        OnNetChangeEncodeType(all_net_encode_type, all_net_video_quality);
    }
    else
    {
        for(var m = 0; m < g_channelList.length; m++)
	    {
	        OnNetChangeEncodeType(net_encode_type[m], net_video_quality[m]);
	    }
    }
	    
    if(g_minorEncodeSizeAllCh)
    {
        for(var i = 0; i < net_resolution.length; i++)
        {
            net_resolution[i].disabled = true;
        }
    }
    
    for(var m = 0; m < net_frame_rate.length; m++)
	{
	    net_frame_rate[m].disabled = true;
	}
}

function OnNetChangeResolution(resolutionObj, channelIndex)
{
    var preMaxRate = net_frame_rate[channelIndex].options.length;
    var preFrameRate = parseInt(net_frame_rate[channelIndex].value,10);
    
    GenSelectListEx(net_frame_rate[channelIndex], g_minorEncodeProperty[resolutionObj.selectedIndex].frameRate);
    var curMaxRate = g_minorEncodeProperty[resolutionObj.selectedIndex].frameRate.length;
    net_frame_rate[channelIndex].value = Math.round(preFrameRate*curMaxRate/preMaxRate);
}

function OnAllNetChangeResolution(resolutionObj)
{
    var preMaxRate = all_net_frame_rate.options.length;
    var preFrameRate = parseInt(all_net_frame_rate.value,10);
    var frameRateArray = g_minorEncodeProperty[resolutionObj.selectedIndex].frameRate;
    var newFrameRateArray = new Array();
    for(var i = 0; i < frameRateArray.length; i++)
    {
        newFrameRateArray[i] = new CSelectOptionInfo(frameRateArray[i].optionName + "X" + const_channel_num, frameRateArray[i].optionValue);
    }
    GenSelectListEx(all_net_frame_rate, newFrameRateArray);
    var curMaxRate = frameRateArray.length;
    all_net_frame_rate.value = Math.round(preFrameRate*curMaxRate/preMaxRate);
}

function OnNetChangeEncodeType(encodeModeObj, videoQualityObj)
{
     if(encodeModeObj.value == 1)
     {
         videoQualityObj.disabled = false;
     }
     else if(encodeModeObj.value == 2)
     {
         videoQualityObj.disabled = true;
     }
     
     if(encodeModeObj.parentNode.style.display == "none")
     {
        videoQualityObj.disabled = false;
     }
}

function TryNetFrameRate(channelIndex)
{
    var totalFrameRate = (g_videoFormat == "PAL") ? g_avNetStreamInfo.totalRatePalOnCif : g_avNetStreamInfo.totalRateNtscOnCif;
    var frameNum = 0;
    for(var ch = 0; ch < net_frame_rate.length; ch++)
    {
        frameNum += ConvertCifRate(parseInt(net_frame_rate[ch].value, 10), parseInt(net_resolution[ch].value, 10));
    }
    
    if(frameNum > totalFrameRate)
    {
        window.alert(str_total_frame_rate_exceed);
        net_frame_rate[channelIndex].value = 
        parseInt(net_frame_rate[channelIndex].value)-Math.ceil((frameNum-totalFrameRate)/MultiCif(net_resolution[channelIndex].value));
    }
    
    frameNum = 0;
    for(var ch = 0; ch < net_frame_rate.length; ch++)
    {
        frameNum += ConvertCifRate(parseInt(net_frame_rate[ch].value, 10), parseInt(net_resolution[ch].value, 10));
    }
    
    var leftSource = (totalFrameRate - frameNum);
    remain_source.innerText = str_source_remain + ": " + leftSource + "(CIF) , " + Math.floor(leftSource/4) + "(D1).";
}

function TryAllNetFrame()
{
    var totalFrameRate = (g_videoFormat == "PAL") ? g_avNetStreamInfo.totalRatePalOnCif : g_avNetStreamInfo.totalRateNtscOnCif;
    var frameNum = net_frame_rate.length * ConvertCifRate(parseInt(all_net_frame_rate.value, 10), parseInt(all_net_resolution.value, 10));
    
    if(frameNum > totalFrameRate)
    {
        window.alert(str_total_frame_rate_exceed);
        all_net_frame_rate.value = Math.floor(totalFrameRate/net_frame_rate.options.length/MultiCif(all_net_resolution.value));
    }
    
    frameNum = net_frame_rate.length * ConvertCifRate(parseInt(all_net_frame_rate.value, 10), parseInt(all_net_resolution.value, 10));
    var leftSource = (totalFrameRate - frameNum);
    remain_source.innerText = str_source_remain + ": " + leftSource + "(CIF) , " + Math.floor(leftSource/4) + "(D1).";
}

function UpdateNetwork(bXml2Html)
{
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	for(var i = 0; i < paramElements.length; i++)
	{
	    var attrib = paramElements[i].getAttribute("name");
	    if(attrib == STR_NETWORK)
	    {
	        var values = paramElements[i].childNodes[0].nodeValue.split('+');
	        if(bXml2Html)
	        {
	            for(var k = 0; k < ip_type.length; k++)
			    {
			        if (ip_type[k].value == values[0])
				    {
				        ip_type[k].checked = true;
				        break;
				    }
			    }
		        MultiEdit.all[ip_address.ipName].setValue(values[1]);
		        MultiEdit.all[net_mask.ipName].setValue(values[2]);
		        MultiEdit.all[gate_way.ipName].setValue(values[3]);
	        }
	        else
	        {
	            for(var k = 0; k < ip_type.length; k++)
			    {
			        if (ip_type[k].checked)
				    {
				        values[0] = ip_type[k].value;
				        break;
				    }
			    }
	            values[1] = MultiEdit.all[ip_address.ipName].getValue();
		        values[2] = MultiEdit.all[net_mask.ipName].getValue();
		        values[3] = MultiEdit.all[gate_way.ipName].getValue();
		        paramElements[i].childNodes[0].nodeValue = values.join('+');
	        }
	    }
	    else if(attrib == STR_DDNS_INFO)
	    {
	        //解析字符串bEnable+bUseDomain+type+user+password[+domain]
	        var configValue = paramElements[i].childNodes[0].nodeValue;
	        var bEnable = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf('+')+1);
	        var bUseDomain = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf('+')+1);
	        var type = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf('+')+1);
	        var userLen = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf(':')+1);
	        var user = configValue.SubStringOfBytes(0, userLen);
	        configValue = configValue.substr(user.length+1);
	        var passwordLen = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf(':')+1);
	        var password = configValue.SubStringOfBytes(0, passwordLen);
	        configValue = configValue.substr(password.length);
	        var domain = "";
	        if(bUseDomain)
	        {
	            configValue = configValue.substr(configValue.indexOf('+')+1);
	            var domainLen = parseInt(configValue,10);
	            configValue = configValue.substr(configValue.indexOf(':')+1);
	            domain = configValue.substr(0, domainLen);
	        }
	        if(bXml2Html)
	        {
	            ddns_enable.checked = bEnable;
                ddns_type.value = type.toString();
                ddns_username.value = user;
                ddns_password.value = password;
                ddns_domain_info.value = (bUseDomain ? domain : "");
	        }
	        else
	        {
	            bEnable = (ddns_enable.checked ? '1' : '0');
	            type = ddns_type.value;
	            user = ddns_username.value;
	            password = ddns_password.value;
	            domain = ddns_domain_info.value;
	            bUseDomain = ((domain == "") ? '0' : '1');
	            
	            configValue = bEnable+'+'+bUseDomain+'+'+type+'+'+user.size()+':'+user+'+'+password.size()+':'+password;
	            if(bUseDomain)
	            {
	                configValue += '+'+domain.size()+':'+domain;
	            }

	            paramElements[i].childNodes[0].nodeValue = configValue;
	        }
	    }
	    else if(attrib == STR_PPPOE_INFO)
	    {
	       //解析字符串bEnable+user+password
	        var configValue = paramElements[i].childNodes[0].nodeValue;
	        var bEnable = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf('+')+1);
	        var userLen = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf(':')+1);
	        var user = configValue.SubStringOfBytes(0, userLen);
	        configValue = configValue.substr(user.length+1);
	        var passwordLen = parseInt(configValue,10);
	        configValue = configValue.substr(configValue.indexOf(':')+1);
	        var password = configValue.SubStringOfBytes(0, passwordLen);
	        if(bXml2Html)
	        {
	            pppoe_enable.checked = bEnable;
                pppoe_username.value = user;
                pppoe_password.value = password;
	        }
	        else
	        {
	            bEnable = (pppoe_enable.checked ? '1' : '0');
	            user = pppoe_username.value;
	            password = pppoe_password.value;
	            
	            configValue = bEnable+'+'+user.size()+':'+user+'+'+password.size()+':'+password;
	            paramElements[i].childNodes[0].nodeValue = configValue;
	        }
	    }
	}
}

function UpdateNetStreamCfg(bXml2Html)
{
    var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
    for(var i = 0; i < paramElements.length; i++)
    {
        if(paramElements[i].getAttribute("name") == STR_ENCODE_MINOR)
        {
            if(bXml2Html)
            {
                for(var j = 0; j < g_channelList.length; j++)
                {
                    //resolution+rate+encodeType+quality+hBitStream
                    var values = paramElements[i].childNodes[0].nodeValue.split('+');
                    net_resolution[j].value = values[0];
                    if(net_frame_rate[j].options.length > 0)
                    {
                        net_frame_rate[j].value = Math.min(parseInt(values[1],10), parseInt((net_frame_rate[j][net_frame_rate[j].options.length-1].value),10));
                    }
                    net_encode_type[j].value = values[2];
                    net_video_quality[j].value = values[3];
                    net_maxbit_stream[j].value = values[4];
                    i++;
                }
                i--;    //因为这一轮循环完之后，i会再加1
            }
            else
            {
                var values = paramElements[i].childNodes[0].nodeValue.split('+');
                for(var j = 0; j < g_channelList.length; j++)
                {
                    //resolution+rate+encodeType+quality+hBitStream
                    if(net_all_cfg.checked)
                    {
                        values[0] = all_net_resolution.value;
                        values[1] = all_net_frame_rate.value;
                        values[2] = all_net_encode_type.value;
                        values[3] = all_net_video_quality.value;
                        values[4] = all_net_maxbit_stream.value;
                    }
                    else
                    {
                        values[0] = net_resolution[j].value;
                        values[1] = net_frame_rate[j].value;
                        values[2] = net_encode_type[j].value;
                        values[3] = net_video_quality[j].value;
                        values[4] = net_maxbit_stream[j].value;
                    }                    
                    paramElements[i].childNodes[0].nodeValue = values.join('+');
                    i++;
                }
                i--;    //因为这一轮循环完之后，i会再加1
            }
        }
    }
}

/***********************************************************************************/
/*************************网络码流页面动态生成表格**********************************/
/***********************************************************************************/
function CreateListNet(htmlObj, rowInitNum)
{
	var strOuterHTML = htmlObj.outerHTML.toLowerCase();
	var lengthLimit = strOuterHTML.indexOf("</tbody>");
	strOuterHTML = strOuterHTML.substr(0, lengthLimit);
	
	var colNum = 6;
	//添加标题行
	strOuterHTML += "<tr style='background-color:#D4E8FE'>";
	for(var i = 0; i < colNum; i++)
	{
	    if(!g_supportMinorEncTypeAndBitrate && ((3 == i) || (5 == i)))
	    {
		    strOuterHTML += "<td style = \"text-align:center;display:none;\">" + cfg_netstream_header[i] + "</td>";
        }
        else
        {
            strOuterHTML += "<td style = \"text-align:center\">" + cfg_netstream_header[i] + "</td>";
        }
	}
	strOuterHTML += "</tr>";
	
	var colWidth = Math.round(633/(colNum-1));
	if(!g_supportMinorEncTypeAndBitrate)
	{
	    colWidth = Math.round(633/(colNum-3));
	}
	
	//添加数据行
	for(var i = 1; i < rowInitNum + 1; i++)
	{
		strOuterHTML += "<tr>";
		strOuterHTML += "<td style = \"width:50px;text-align:center\">"+i+"</td>";
	    strOuterHTML +="<td><select name = \"net_resolution\" style = \"width:"+colWidth+"px;\" onchange = \"g_bChange = true; OnNetChangeResolution(this, "+(i-1)+")\"></select></td>";
	    strOuterHTML +="<td><select name = \"net_frame_rate\" style = \"width:"+colWidth+"px;\" onchange = \"g_bChange = true; TryNetFrameRate("+(i-1)+")\"></select></td>";
	    if(!g_supportMinorEncTypeAndBitrate)
	    {
	        strOuterHTML +="<td style=\"display:none;\"><select name = \"net_encode_type\"></select></td>";
	    }
	    else
	    {
	        strOuterHTML +="<td><select name = \"net_encode_type\" style = \"width:"+colWidth+"px;\" onchange = \"g_bChange = true; OnNetChangeEncodeType(this,net_video_quality["+(i-1)+"])\"></select></td>";
	    }
	    strOuterHTML +="<td><select name = \"net_video_quality\" style = \"width:"+colWidth+"px;\" onchange = \"g_bChange = true;\"></select></td>";
	    if(!g_supportMinorEncTypeAndBitrate)
	    {
	        strOuterHTML +="<td style=\"display:none;\"><select name = \"net_maxbit_stream\"></select></td>";
	    }
	    else
	    {
	        strOuterHTML +="<td><select name = \"net_maxbit_stream\" style = \"width:"+colWidth+"px;\" onchange = \"g_bChange = true;\"></select></td>";
	    }
		strOuterHTML += "</tr>";
	}
	strOuterHTML += "</tbody></table>";
	var parentNode = htmlObj.parentElement;
	parentNode.innerHTML = strOuterHTML;
	for(var i = 1; i < rowInitNum + 1; i++)
	{
	    GenSelectListEx(document.getElementsByName("net_resolution")[i-1], g_minorEncodeProperty);
		GenSelectListEx(document.getElementsByName("net_encode_type")[i-1], g_avNetStreamInfo.supportEncodeMode);
	    GenSelectListEx(document.getElementsByName("net_video_quality")[i-1], g_avNetStreamInfo.supportQuarlity);
	    GenSelectListEx(document.getElementsByName("net_maxbit_stream")[i-1], g_avNetStreamInfo.supportBitrate);
	}
	htmlObj = parentNode.childNodes[0];
	
	all_net_resolution.style.width = colWidth;
    all_net_frame_rate.style.width = colWidth;
    all_net_encode_type.style.width = colWidth;
    all_net_video_quality.style.width = colWidth;
    all_net_maxbit_stream.style.width = colWidth;
    
    if(!g_supportMinorEncTypeAndBitrate)
    {
        all_net_encode_type.parentNode.style.display = "none";
        all_net_maxbit_stream.parentNode.style.display = "none";
    }
}

/*************************************************************************
   Authentication of length  in  NetConfig page
*************************************************************************/
function ConstNetConfiglen()
{
    var error_message1 = "";
    var error_message2 = "";
    var error_message3 = "";
    var error_message4 = "";
    var error_message5 = "";
    var error_message6 = "";
    var error_message7 = "";
    //获得实际输入字符的长度
    pppoe_username_len = pppoe_username.value.length;
    pppoe_password_len = pppoe_password.value.length;
    ddns_username_len = ddns_username.value.length;
    ddns_password_len = ddns_password.value.length;
    ddns_domain_info_len = ddns_domain_info.value.length;
    //获取错误输出信息的DIV
    var netconfig_errortips = document.getElementById("netconfig_errortips");
    //定位错误信息
    var id_pppoe_username = document.getElementById("id_pppoe_username");
    var id_pppoe_password = document.getElementById("id_pppoe_password");
    var id_ddns_username = document.getElementById("id_ddns_username");
    var id_ddns_password = document.getElementById("id_ddns_password");
    var id_ddns_domain_info = document.getElementById("id_ddns_domain_info");
	var isValid = true;
	//输入字符的长度与限定值做比较
    if (pppoe_username_len>const_pppoe_username_max_len)
    {
		error_message2 = "<br>"+"PPPoE "+id_pppoe_username.innerHTML+cannot_more_than_tip+const_pppoe_username_max_len+"!";
		isValid = false;
    }
    if (pppoe_password_len>const_pppoe_password_max_len)
    {
        error_message3 = "<br>"+"PPPoE "+id_pppoe_password.innerHTML+cannot_more_than_tip+const_pppoe_password_max_len+"!";
        isValid = false;
    }
    if (ddns_username_len>const_ddns_uername_max_len)
    {
		error_message4 = "<br>"+"DDNS "+id_ddns_username.innerHTML+cannot_more_than_tip+const_ddns_uername_max_len+"!";
		isValid = false;
    }
    if (ddns_password_len>const_ddns_password_max_len)
    {
		error_message5 = "<br>"+"DDNS "+id_ddns_password.innerHTML+cannot_more_than_tip+const_ddns_password_max_len+"!";
		isValid = false;
    }
    if (ddns_domain_info_len>const_ddns_domain_max_len)
    {
        error_message6 = "<br>"+id_ddns_domain_info.innerHTML+cannot_more_than_tip+const_ddns_domain_max_len+"!";
		isValid = false;
    }
    if(http_port.value == server_port.value)
    {
        error_message7 = "<br>" + str_http_data_port_conflict;
        isValid = false;
    }
	if(!isValid)
	{
	    netconfig_errortips.style.color = "red";
		netconfig_errortips.innerHTML = save_error_tip+error_message2+error_message3+error_message4+error_message5+error_message6+error_message7;
		return false;
	}
	netconfig_errortips.innerHTML = "";
	netconfig_errortips.display = "none";
	return true;
}

//netconfig readonly control
function UpnpEnable(obj)
{
    var upnp_name = document.getElementsByName("upnp_name");
    upnp_name[0].disabled = !obj.checked;
}
//静态IP
function IPType()
{
    var ip_address = document.getElementsByName("ip_address");
    ip_address[0].disabled = ip_type[0].checked;
    var net_mask = document.getElementsByName("net_mask");
    net_mask[0].disabled = ip_type[0].checked;
    var gate_way = document.getElementsByName("gate_way");
    gate_way[0].disabled =ip_type[0].checked;
    var net_dns1 = document.getElementsByName("net_dns1");
    net_dns1[0].disabled = ip_type[0].checked;
    var net_dns2 = document.getElementsByName("net_dns2");
    net_dns2[0].disabled = ip_type[0].checked;
}
function IPAuto(obj)
{
    if(obj.checked)
    {
        MultiEdit.all["ip1"].setEnable(false);
        MultiEdit.all["ip2"].setEnable(false);
        MultiEdit.all["ip3"].setEnable(false);
    }
}
function IPStatic(obj)
{
    if(obj.checked)
    {
        MultiEdit.all["ip1"].setEnable(true);
        MultiEdit.all["ip2"].setEnable(true);
        MultiEdit.all["ip3"].setEnable(true);
    }
}
//启用PPPoE
function PPPoeEnable(obj)
{
    var pppoe_username = document.getElementsByName("pppoe_username");
    pppoe_username[0].disabled = !obj.checked;
    var pppoe_password = document.getElementsByName("pppoe_password");
    pppoe_password[0].disabled = !obj.checked;
    
    if(obj.checked)
    {
        ip_type[0].disabled = true;
        ip_type[1].disabled = true;
        MultiEdit.all["ip1"].setEnable(false);
        MultiEdit.all["ip2"].setEnable(false);
        MultiEdit.all["ip3"].setEnable(false);
    }
    else
    {
        ip_type[0].disabled = false;
        ip_type[1].disabled = false;
        IPStatic(ip_type[1]);
    }
}
//启用DDNS
function DdnsEnable(obj)
{
    ddns_type.disabled = !obj.checked;
    ddns_username.disabled = !obj.checked;
    ddns_password.disabled = !obj.checked;
    ddns_domain_info.disabled = !obj.checked;
    ddns_update_cycle.disabled = !obj.checked;
    ddns_test_btn.disabled = !obj.checked;
    
    if(obj.checked)
    {
        DisDomain(ddns_type);
    }
}
//使用IP地址过滤
function FilterIpIf(obj)
{
    var filter_ip_mode = document.getElementsByName("filter_ip_mode");
    filter_ip_mode[0].disabled = !obj.checked;
    filter_ip_mode[1].disabled = !obj.checked;
}
//
function DisDomain(obj)
{
    for(i = 0;i<ddns_type.length;i++)
    {
        if(obj.options[i].selected)
        {
            if (g_ddnsDomainInfo[i].hasDomain == "1")
            {
                ddns_domain_info.disabled = false;
                ddns_test_btn.disabled = false;
            }
            else
            {
                ddns_domain_info.disabled = true;
                if(g_ddnsDomainInfo[i].ddnsId == "0")
                {
                    ddns_test_btn.disabled = true;
                }
				else
				{
					ddns_test_btn.disabled = false;
				}
            }
        }
    }
}

function NetworkTestDHCP()
{
    var values = new Array();
    for(var k = 0; k < ip_type.length; k++)
    {
        if (ip_type[k].checked)
	    {
	        values[0] = ip_type[k].value;
	        break;
	    }
    }
    values[1] = MultiEdit.all[ip_address.ipName].getValue();
    values[2] = MultiEdit.all[net_mask.ipName].getValue();
    values[3] = MultiEdit.all[gate_way.ipName].getValue();
    
    var xmlDoc = createXMLDoc();
    var cmdElem = xmlDoc.createElement("command");
    var paramElem = xmlDoc.createElement("parameter");
    var textNode = xmlDoc.createTextNode(values.join('+'));
    
    paramElem.appendChild(textNode);
    
    cmdElem.setAttribute("name", STR_NETWORK_TEST_DHCP);
    cmdElem.appendChild(paramElem);
    
    xmlDoc.documentElement = xmlDoc.createElement("request");
    xmlDoc.documentElement.appendChild(cmdElem);
    
    var strResult = WebClient.ExcuteCmd(xmlDoc.xml);
    if(strResult == "")
    {
        return;
    }
    else
    {
        xmlDoc.async = false;
        xmlDoc.loadXML(strResult);
        var cmdElem = xmlDoc.documentElement.childNodes[0];
        
        if(cmdElem.getAttribute("name") == STR_NETWORK_TEST_SUCC)
        {
            g_bNetworkPassTest = true;
            window.alert(str_testsuccess);
        }
        else
        {
            g_bNetworkPassTest = false;
            window.alert(str_testfailed);
        }
    }
}

function NetworkTestPPPoE()
{
    var bEnable = (pppoe_enable.checked ? '1' : '0');
    var user = pppoe_username.value;
    var password = pppoe_password.value;
    var configValue = bEnable+'+'+user.size()+':'+user+'+'+password.size()+':'+password;

    var xmlDoc = createXMLDoc();
    var cmdElem = xmlDoc.createElement("command");
    var paramElem = xmlDoc.createElement("parameter");
    var textNode = xmlDoc.createTextNode(configValue);
    
    paramElem.appendChild(textNode);
    
    cmdElem.setAttribute("name", STR_NETWORK_TEST_PPPOE);
    cmdElem.appendChild(paramElem);
    
    xmlDoc.documentElement = xmlDoc.createElement("request");
    xmlDoc.documentElement.appendChild(cmdElem);
    
    var strResult = WebClient.ExcuteCmd(xmlDoc.xml);
    if(strResult == "")
    {
        return;
    }
    else
    {
        xmlDoc.async = false;
        xmlDoc.loadXML(strResult);
        var cmdElem = xmlDoc.documentElement.childNodes[0];
        
        if(cmdElem.getAttribute("name") == STR_NETWORK_TEST_SUCC)
        {
			g_bNetworkPassTest = true;
            window.alert(str_testsuccess);
        }
        else
        {
            g_bNetworkPassTest = false;
            window.alert(str_testfailed);
        }
    }
}


function NetworkTest()
{
    if(pppoe_enable.checked)
    {
        NetworkTestPPPoE();
    }
    else
    {
        NetworkTestDHCP();
    }
}

function NetworkTestDDNS(bSilence)
{
    var bEnable = (ddns_enable.checked ? '1' : '0');
    var type = ddns_type.value;
    var user = ddns_username.value;
    var password = ddns_password.value;
    var domain = ddns_domain_info.value;
    var bUseDomain = ((domain == "") ? '0' : '1');
    
    var configValue = bEnable+'+'+bUseDomain+'+'+type+'+'+user.size()+':'+user+'+'+password.size()+':'+password;
    if(bUseDomain)
    {
        configValue += '+'+domain.size()+':'+domain;
    }
	            
    var xmlDoc = createXMLDoc();
    var cmdElem = xmlDoc.createElement("command");
    var paramElem = xmlDoc.createElement("parameter");
    var textNode = xmlDoc.createTextNode(configValue);
    
    paramElem.appendChild(textNode);
    
    cmdElem.setAttribute("name", STR_NETWORK_TEST_DDNS);
    cmdElem.appendChild(paramElem);
    
    xmlDoc.documentElement = xmlDoc.createElement("request");
    xmlDoc.documentElement.appendChild(cmdElem);

    var strResult = WebClient.ExcuteCmd(xmlDoc.xml);
    if(strResult == "")
    {
        return false;
    }
    else
    {
        xmlDoc.async = false;
        xmlDoc.loadXML(strResult);
        var cmdElem = xmlDoc.documentElement.childNodes[0];
        
        if(cmdElem.getAttribute("name") == STR_NETWORK_TEST_SUCC)
        {
            g_bDDNSPassTest = true;
            if(!bSilence)
            {
                window.alert(str_testsuccess);
            }
            return true;
        }
        else
        {
            g_bDDNSPassTest = false;
            if(!bSilence)
            {
                window.alert(str_testfailed);
            }
            return false;
        }
    }
    
    return false;
}

function OnLoadCfgMail()
{
    ApplyXmlLang("cfg_net_mail.xml");
	GenSelectListEx(email_pic_acc, g_emailSnapNumArray);
	GenSelectListEx(jpeg_period, g_emailSnapPeriodArray);
    
    var xmlConfigReq = CreateConfigReqXml(email_config_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return false;
	}
	
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
 	UpdateNetMail(g_xmlDoc.documentElement.childNodes[0].childNodes, true);
}

function LoadDefaultCfgMail()
{
    if(GetDefaultCfg(email_config_array))
    {
        UpdateNetMail(g_xmlDoc.documentElement.childNodes[0].childNodes, true);
	    g_bChange = true;
    }
}

function UpdateNetMail(xmlElements, bXml2Html)
{
    for(i = 0; i < xmlElements.length; i++)
    {
        if(bXml2Html)
        {
            if(STR_EMAIL_SEND_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                var sendMessage = xmlElements[i].childNodes[0].nodeValue;
                bSSL = parseInt(sendMessage,10);//1
                mail_sll_check.checked = bSSL?true:false;//SLL check
                var pIndex = sendMessage.indexOf("+");
                port = sendMessage.substr(pIndex+1);
                mail_port.value = parseInt(port,10);//smtp port
                var serverLenIndex = port.indexOf("+");
                var serverLenData = port.substr(serverLenIndex+1);
                var serverLen = parseInt(serverLenData,10);
                var serverIndex = serverLenData.indexOf(":");
                mail_smtp_server.value = serverLenData.SubStringOfBytes(serverIndex+1,serverLen);// smtp server address 
                var sendNameData = serverLenData.SubStringOfBytes(serverIndex+serverLen+1);
                var nameLen = parseInt(sendNameData,10);
                var nameIndex = sendNameData.indexOf(":");
                mail_send_addr.value = sendNameData.substr(nameIndex+1,nameLen);//send address
                var pwdData = sendNameData.substr(nameIndex+nameLen+1);
                var pwdLen = parseInt(pwdData,10);
                var pwdIndex = pwdData.indexOf(":");
                mail_send_addr_pwd.value = pwdData.substr(pwdIndex+1);
            }
            if(STR_EMAIL_RECV_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                var index = xmlElements[i].attributes.getNamedItem("index").nodeValue;
                if(xmlElements[i].childNodes[0] == null)
                {
                    mail_receive_addr[index].value = "";
                    continue;
                }
                mail_receive_addr[index].value = xmlElements[i].childNodes[0].nodeValue;
            }
            if(STR_EMAIL_PIC_ACC == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                email_pic_acc.value = xmlElements[i].childNodes[0].nodeValue;
            }
            if(STR_JPEG_PERIOD == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                jpeg_period.value = xmlElements[i].childNodes[0].nodeValue;
            }
        }
        else
        {
            if(STR_EMAIL_SEND_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                xmlElements[i].childNodes[0].nodeValue = "";
                var bSLL = (mail_sll_check.checked)?1:0;
                xmlElements[i].childNodes[0].nodeValue = bSLL+"+"+mail_port.value+"+"+mail_smtp_server.value.size()+":"+mail_smtp_server.value+"+"+mail_send_addr.value.size()+":"+mail_send_addr.value+"+"+mail_send_addr_pwd.value.size()+":"+mail_send_addr_pwd.value;
            }
            if(STR_EMAIL_RECV_INFO == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                var index = xmlElements[i].attributes.getNamedItem("index").nodeValue;
                if(xmlElements[i].childNodes[0] == null)
                {
                    var tempA = g_xmlDoc.createTextNode("");
                    xmlElements[i].appendChild(tempA);
                }
                xmlElements[i].childNodes[0].nodeValue  = mail_receive_addr[index].value;
            }
            if(STR_EMAIL_PIC_ACC == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                xmlElements[i].childNodes[0].nodeValue = email_pic_acc.value;
            }
            if(STR_JPEG_PERIOD == xmlElements[i].attributes.getNamedItem("name").nodeValue)
            {
                xmlElements[i].childNodes[0].nodeValue = jpeg_period.value;
            }
        }
    }
}

var g_CheckEmail = 0;

function CheckEmailNow()
{
    StartWaitTip(str_mail_test_wait_tip);
    g_CheckEmail = setTimeout("CheckEmail()", 100);
}

function CreateEmailCheckXML()
{
    var testXmlDoc = createXMLDoc();
    var rootElement = testXmlDoc.createElement("request");
    var commandElement = testXmlDoc.createElement("command");
    commandElement.setAttribute("name", STR_EMAIL_CHECK);
    //SENDER
    var senderElement = testXmlDoc.createElement(STR_MAIL_SENDER);
    //SSL
    var bSLL = (mail_sll_check.checked)?1:0;
    var paramElement = testXmlDoc.createElement(STR_USE_SSL);
    var textNode = testXmlDoc.createTextNode(bSLL);
    paramElement.appendChild(textNode);
    senderElement.appendChild(paramElement);
    //smtp port
    paramElement = testXmlDoc.createElement(STR_SMTP_PORT);
    textNode = testXmlDoc.createTextNode(mail_port.value);
    paramElement.appendChild(textNode);
    senderElement.appendChild(paramElement);
    //smtp server
    paramElement = testXmlDoc.createElement(STR_SMTP_SERVER);
    textNode = testXmlDoc.createTextNode(mail_smtp_server.value);
    paramElement.appendChild(textNode);
    senderElement.appendChild(paramElement);
    //mail account
    paramElement = testXmlDoc.createElement(STR_MAIL_ACCOUNT);
    textNode = testXmlDoc.createTextNode(mail_send_addr.value);
    paramElement.appendChild(textNode);
    senderElement.appendChild(paramElement);
    //mail password
    paramElement = testXmlDoc.createElement(STR_MAIL_PASSWORD);
    textNode = testXmlDoc.createTextNode(mail_send_addr_pwd.value);
    paramElement.appendChild(textNode);
    senderElement.appendChild(paramElement);
    commandElement.appendChild(senderElement);
    var recverElement = testXmlDoc.createElement(STR_MAIL_RECVER);
    for(var i = 0; i < mail_receive_addr.length; i++)
    {
        paramElement = testXmlDoc.createElement(STR_MAIL_ACCOUNT);
        textNode = testXmlDoc.createTextNode(mail_receive_addr[i].value);
        paramElement.appendChild(textNode);
        recverElement.appendChild(paramElement);
    }
    commandElement.appendChild(recverElement);
    rootElement.appendChild(commandElement);    
    testXmlDoc.appendChild(rootElement);
    return testXmlDoc.xml;
}
function CheckEmail()
{
    var requestCommand = CreateEmailCheckXML();
    var xmlTestReply = WebClient.ExcuteCmd(requestCommand);
    
	if(xmlTestReply == "")
	{
	    return;
	}
	var testXmlDoc = createXMLDoc();
	testXmlDoc.async = false;
	testXmlDoc.loadXML(xmlTestReply); 
    var cmdElements = testXmlDoc.documentElement.childNodes;
	if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_EMAIL_CHECK_SUCC)
	{
	    StopWaitTip();
	    window.alert(str_mail_test_succ_tip);
	    clearTimeout(g_CheckEmail);
        return;
	}
	if(cmdElements[0].attributes.getNamedItem("name").nodeValue == STR_EMAIL_CHECK_FAIL) 
	{
	    StopWaitTip();
        window.alert(str_mail_test_fail_tip);
        clearTimeout(g_CheckEmail);
        return;
	}
	StopWaitTip();    
    window.alert(str_mail_test_fail_tip);
    clearTimeout(g_CheckEmail);
}
