﻿// JScript 文件

function OnLoadCfgRecSchedule()
{
    try
    {
        g_bEraseMode = false;
        g_curSchType = "rec_sch_week";
        g_curIndexList = g_channelList;
        GenSchedulePage();
	    var xmlConfigReq = CreateConfigReqXml(schedule_rec_array);
	    var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	    if(xmlConfigReply == "")
	    {
	        StopWait();
	        return;
	    }
	    g_xmlDoc.async = false;
	    g_xmlDoc.loadXML(xmlConfigReply);
	    var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	    for(var a = 0; a < g_channelList.length; a++)
        {
            g_sch_holiday[a] = new Array();
        }

	    UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
	    ApplyXmlLang("cfg_schedule.xml");
    }
    catch(e)
    {
        ;
    }
}

function OnLoadCfgRecMotionSchedule()
{
    g_bEraseMode = false;
    g_curSchType = "rec_sch_motion_week";
    g_curIndexList = g_channelList;
    GenSchedulePage();
	var xmlConfigReq = CreateConfigReqXml(sch_motion_rec_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return;
	}
	
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	for(var a = 0; a < g_channelList.length; a++)
    {
        g_sch_holiday[a] = new Array();
    }

	UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
	ApplyXmlLang("cfg_schedule.xml");
//  window.alert(xmlConfigReply);
}

function OnLoadCfgRecSensorSchedule()
{
    g_bEraseMode = false;
    g_curSchType = "rec_sch_sensor_week";
    g_curIndexList = g_channelList;
    GenSchedulePage();
	var xmlConfigReq = CreateConfigReqXml(sch_sensor_rec_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return;
	}
	
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	for(var a = 0; a < g_channelList.length; a++)
    {
        g_sch_holiday[a] = new Array();
    }

	UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
	ApplyXmlLang("cfg_schedule.xml");
//	window.alert(xmlConfigReply);
}

function OnLoadCfgMotionSchedule()
{
    g_bEraseMode = false;
    g_curSchType = STR_MOTION_WEEK_SCH;
    g_curIndexList = g_channelList;
    GenSchedulePage();
	var xmlConfigReq = CreateConfigReqXml(sch_motion_alarm_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return;
	}
	
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	for(var a = 0; a < g_channelList.length; a++)
    {
        g_sch_holiday[a] = new Array();
    }
    
	UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
	ApplyXmlLang("cfg_schedule.xml");
//		window.alert(xmlConfigReply);
}

function OnLoadCfgSensorSchedule()
{
    g_bEraseMode = false;
    g_curSchType = STR_SENSOR_IN_WEEK_SCH;
    g_curIndexList = g_sensorList;
    GenSchedulePage();
	var xmlConfigReq = CreateConfigReqXml(sch_sensor_alarm_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return false;
	}
	
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	for(var a = 0; a < g_channelList.length; a++)
    {
        g_sch_holiday[a] = new Array();
    }

	UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
	ApplyXmlLang("cfg_schedule.xml");
//		window.alert(xmlConfigReply);
}

function OnLoadCfgNetAlarmSchedule()
{
    g_bEraseMode = false;
    g_curSchType = STR_NET_ALARM_WEEK_SCH;
    g_curIndexList = g_channelList;
    GenSchedulePage();
	var xmlConfigReq = CreateConfigReqXml(sch_net_alarm_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return;
	}
	
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	for(var a = 0; a < g_channelList.length; a++)
    {
        g_sch_holiday[a] = new Array();
    }

	UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
	ApplyXmlLang("cfg_schedule.xml");
//		window.alert(xmlConfigReply);
}

function OnLoadCfgAlarmoutSchedule()
{
    g_bEraseMode = false;
    g_curSchType = STR_ALARMOUT_WEEK_SCH;
    g_curIndexList = g_alarmoutList;
    GenSchedulePage();
	var xmlConfigReq = CreateConfigReqXml(sch_alarmout_array);
	var xmlConfigReply = WebClient.ExcuteCmd(xmlConfigReq);
	if(xmlConfigReply == "")
	{
	    return false;
	}
	
//  window.alert(xmlConfigReply);
	g_xmlDoc.async = false;
	g_xmlDoc.loadXML(xmlConfigReply);
	var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
	for(var i = 0; i < g_channelList.length; i++)
    {
        g_sch_holiday[i] = new Array();
    }

	UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
	ApplyXmlLang("cfg_schedule.xml");
}

function LoadDefaultCfgSchedule()
{
    var scheduleItem = new Array(0);
    if(g_curSchType == STR_REC_SCH_WEEK)
    {
        scheduleItem = schedule_rec_array;
    }
    else if(g_curSchType == STR_REC_SCH_MOTION_WEEK)
    {
        scheduleItem = sch_motion_rec_array;
    }
    else if(g_curSchType == STR_REC_SCH_SENSOR_WEEK)
    {
        scheduleItem = sch_sensor_rec_array;
    }
    else if(g_curSchType == STR_MOTION_WEEK_SCH)
    {
        scheduleItem = sch_motion_alarm_array;
    }
    else if(g_curSchType == STR_SENSOR_IN_WEEK_SCH)
    {
        scheduleItem = sch_sensor_alarm_array;
    }
    else if(g_curSchType == STR_NET_ALARM_WEEK_SCH)
    {
        scheduleItem = sch_net_alarm_array;
    }
    else if(g_curSchType == STR_ALARMOUT_WEEK_SCH)
    {
        scheduleItem = sch_alarmout_array;
    }

    if(GetDefaultCfg(scheduleItem))
    {
        var paramElements = g_xmlDoc.documentElement.childNodes[0].childNodes;
        for(var i = 0; i < g_channelList.length; i++)
        {
            g_sch_holiday[i] = new Array();
        }
        UpdateSchedule(paramElements, true,g_curSchChannel,g_curSchType);
    }
}

function UpdateSchedule(xmlElements, bXml2Html,channelIndex,curSchType)
{
	for ( k = 0; k < xmlElements.length; k++)
	{
	    htmlName = xmlElements[k].attributes.getNamedItem("name").nodeValue;
	   
	    if(htmlName == curSchType)
	    {
	        if(xmlElements[k].attributes.getNamedItem("index").nodeValue == g_curSchChannel)
	        {
	            var arrSchDayData = xmlElements[k].childNodes[0].nodeValue.toString().split("*");
	            if(bXml2Html)
	            {
	                for( var m = 0; m < 7; m++)
	                {
	                    SetScheduleData('schedule_div'+m, arrSchDayData[m]);
	                }
	            }
	            else
	            {
	                for( var m = 0; m < 7; m++)
	                {
	                    arrSchDayData[m] = GetScheduleData('schedule_div'+m);
	                }
	                xmlElements[k].childNodes[0].nodeValue = arrSchDayData.join("*");
	            }
	            break;
	        }
	    }
	}
}

function FlushHolidayData(xmlElements,bXml2Html)//从XML读数据到数组或从数组保存数据到XML
{
//     var curSchArray;
//     for(k = 0; k < xmlElements.length; k++)
//     {
//         htmlName = xmlElements[k].attributes.getNamedItem("name").nodeValue;
//         if(htmlName.substr(htmlName.length-8) == "_holiday")
//         {
//             curSchArray = g_sch_holiday;
//             
//             curIndex = xmlElements[k].attributes.getNamedItem("index").nodeValue;
//             if(bXml2Html)
//             {
//                 if(xmlElements[k].childNodes[0] == null)
//                 {
//                     continue;
//                 }
//                 dayData = xmlElements[k].childNodes[0].nodeValue.toString().split("*");
//                 for(m = 0; m < dayData.length-1; m++)
//                 {
//                     splitData = dayData[m].split("+");
//                     tempN = curSchArray[curIndex].length;
//                     curSchArray[curIndex][tempN] = new HolidaySchData(splitData[0],splitData[1]);
//                 }
//             }
//             else
//             {
//                 tempArray = new Array();
//                 for(j = 0;j < curSchArray[curIndex].length; j++)
//                 {
//                     var temp1 = curSchArray[curIndex][j].dateInfo;
//                     var temp2 = curSchArray[curIndex][j].schInfo;
//                     tempArray[j] = (temp1+"+"+temp2).toString();
//                 }
//                 if(tempArray.length != 0)
//                 {
//                     if(xmlElements[k].childNodes[0] == null)
//                     {
//                         var tempA = g_xmlDoc.createTextNode("");
//                         xmlElements[k].appendChild(tempA);
//                     }
//                     xmlElements[k].childNodes[0].nodeValue = tempArray.join("*")+"*";
//                 }
//             }
//         }
//      }
}
function UpdateHoliday(xmlElements,bXml2Html,curHoliData)
{
//     var curSchArray;
//     for(k = 0; k < xmlElements.length; k++)
//     {
//         htmlName = xmlElements[k].attributes.getNamedItem("name").nodeValue;
//         if(htmlName.substr(htmlName.length-8) == "_holiday")
//         {
//             curSchArray = g_sch_holiday;
//             
//             if(xmlElements[k].attributes.getNamedItem("index").nodeValue == g_curSchChannel)
//             {
//                 if(curSchArray[g_curSchChannel].length == 0)
//                 {
//                     if(bXml2Html)
//                     {
//                        continue; 
//                     }
//                     else
//                     {
//                         var tempA = g_xmlDoc.createTextNode("");
//                         xmlElements[k].appendChild(tempA);
//                     }
//                 }
//                 else if(xmlElements[k].childNodes[0] == null)
//                 {
//                     var tempA = g_xmlDoc.createTextNode("");
//                     xmlElements[k].appendChild(tempA);
//                 }
//                 var arrHolidayData = new Array(curSchArray[g_curSchChannel].length);
//                 for(var n = 0; n < curSchArray[g_curSchChannel].length; n++)
//                 {
//                     var tempData = new Array(2);
//                     tempData[0] = curSchArray[g_curSchChannel][n].dateInfo;
//                     tempData[1] = curSchArray[g_curSchChannel][n].schInfo;
//                     arrHolidayData[n] =  tempData.join("+");
//                 }
//                 for(m = 0; m < holiday_sch.length; m++)
//                 {
//                     if(bXml2Html)
//                     {
//                         if(curHoliData == curSchArray[g_curSchChannel][m].dateInfo)
//                         {
//                             if(curSchArray[g_curSchChannel][m].schInfo == "")
//                             {
//                                 curSchArray[g_curSchChannel][m].schInfo = g_96zero;
//                             }
//                             SetScheduleData("sch_holiday",curSchArray[g_curSchChannel][m].schInfo);
//                         }
//                     }
//                     else
//                     {
//                         var tempD = GetScheduleData("sch_holiday");
//                         if(tempD == g_96zero)
//                         {
//                             continue;
//                         }
//                         if(curSchArray[g_curSchChannel][m].dateInfo == curHoliData)
//                         {
//                             curSchArray[g_curSchChannel][m].schInfo = GetScheduleData("sch_holiday");
//                             var temp = new Array(2);
//                             temp[0] = curSchArray[g_curSchChannel][m].dateInfo;
//                             temp[1] = curSchArray[g_curSchChannel][m].schInfo;
//                             arrHolidayData[m] = temp.join("+");
//                             break;
//                         }
//                         if(holiday_sch.length == 0)
//                         {
//                             xmlElements[k].childNodes[0].nodeValue = "";
//                         }
//                         else
//                         {
//                             xmlElements[k].childNodes[0].nodeValue = arrHolidayData.join("*")+"*";
//                         }
//                     }
//                 }
//             }
//         }
//     }
}

//copy week data
function SchWeekCopy(xmlElements,curChannel,copyChannel)
{
    for(k = 0; k < xmlElements.length; k++)
    {
        htmlName = xmlElements[k].attributes.getNamedItem("name").nodeValue;
        if(xmlElements[k].attributes.getNamedItem("index").nodeValue == curChannel)
        {
            if(htmlName == g_curSchType)
            {
                curSchData = xmlElements[k].childNodes[0].nodeValue;
                break;
            }
        }
    }
    for(k = 0; k < xmlElements.length; k++)
    {
        htmlName = xmlElements[k].attributes.getNamedItem("name").nodeValue;
        if(copyChannel != "All")
        {
            if(xmlElements[k].attributes.getNamedItem("index").nodeValue == copyChannel)
            {                     
                if(htmlName == g_curSchType)
                {
                    xmlElements[k].childNodes[0].nodeValue = curSchData ;
                }
            }
        }
        else
        {
            if(xmlElements[k].attributes.getNamedItem("index").nodeValue == 0)
            {
                if(htmlName == g_curSchType)
                {
                    for(j = 0; j < g_channelList.length; j++)
                    {
                        xmlElements[k+j].childNodes[0].nodeValue = curSchData;
                    }
                }
            }
        }
    }
}
// copy holiday data
function schCopy(copyObj)
{
    UpdateSchedule(g_xmlDoc.documentElement.childNodes[0].childNodes, false,g_curSchChannel,g_curSchType);
    var selectchannel = copyObj.value;
    SchWeekCopy(g_xmlDoc.documentElement.childNodes[0].childNodes,g_curSchChannel,selectchannel);
}
