#!/bin/sh

modprobe h2gether port_mode=1
modprobe nfs

PCI_DEV_3520_NA=`grep -i '19e53520' /proc/bus/pci/devices`
if [ "$PCI_DEV_3520_NA" = "" ]; then
    echo "current product used one td3520 device"
    cd /mnt/mtd/modules && ./load_master -s
else
    echo "current product used multi td3520 device"
    cd /mnt/mtd/modules && ./load_pci_host.sh
fi
 
rm /upgrade/ -rf
rm /mnt/mtd/preupgrade.sh
rm /mnt/mtd/productcheck
telnetd &

export mac=$(cat /etc/init.d/mac.dat)
ifconfig eth0 down
ifconfig eth0 hw ether $mac
ifconfig eth0 up

route add -net 224.0.0.0 netmask 240.0.0.0 dev eth0

mkdir /mnt/backup
mount -t yaffs2 /dev/mtdblock4 /mnt/backup
                                      
cd /mnt/mtd && ./XDVRStart.hisi ./td3520 &
